% dejong's 5th function
% minimum = 0.998;  X = [-32, -32]

function Y = flip_dejong5(X)
% Y is a column vector, X is a matrix, each row of X is a sample

dim = size(X,2);  % dimension of the problem, i.e., length of each sample

a1=[-32, -16, 0, 16, 32, -32, -16, 0, 16, 32, -32, -16, 0, 16, 32, -32, -16, 0, 16, 32, -32, -16, 0, 16, 32];
a2=[-32, -32, -32, -32, -32, -16, -16, -16, -16, -16, 0, 0, 0, 0, 0, 16, 16, 16, 16, 16, 32, 32, 32, 32, 32];
Y=0;
for j=1:25
    Y=Y+(j+sum((X-repmat([a1(j),a2(j)],size(X,1),1)).^6,2)).^(-1);
end
Y=(Y+0.002).^(-1);

% the above part of the dejong5 function was intended for a minization problem,
% since GASS is working under a maximization formulation, we need to flip it
Y = -Y;


