% This file runs the algorithms GASS ang GASS_avg on several benchmark
% problems.

%---sphere function-------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
M=50;
Hl=-2e6;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
disp(j)
%tic
[S1,H1,X1]=GASS(N, K, @flip_sphere, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
%toc
end
H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
std_GASS=std(H_GASS,0,1)/sqrt(A); % standard error
save('H_GASS_sphere','H_GASS')
save('X_GASS_sphere','X_GASS')
save('H_a_GASS_sphere','H_GASS_a')
save('std_err_GASS_sphere','std_GASS')
save('S1_GASS_sphere','S1')
for j=1:A
disp(j)
%tic
[S1,H2,X2]=GASS_avg(N, K, @flip_sphere, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
%toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_sphere','H_GASS_avg')
save('X_GASS_avg_sphere','X_GASS_avg')
save('H_a_GASS_avg_sphere','H_GASS_avg_a')
save('std_err_GASS_avg_sphere','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
title('50-D Sphere function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -10^(6) -10^(-0.2)])


%------------trigonometric function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=600; % number of maxmal iterations
M=50;
Hl=-1e5;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_tri, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_tri','H_GASS')
save('X_GASS_tri','X_GASS')
save('H_a_GASS_tri','H_GASS_a')
save('std_err_GASS_tri','std_GASS')
save('S1_GASS_tri','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_tri, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_tri','H_GASS_avg')
save('X_GASS_avg_tri','X_GASS_avg')
save('H_a_GASS_avg_tri','H_GASS_avg_a')
save('std_err_GASS_avg_tri','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
title('50-D Trigonometric function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -10^(5) -10^(-0.2)])

%---------------griewank function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
M=50;
Hl=-1e3;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_griewank, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_griewank','H_GASS')
save('X_GASS_griewank','X_GASS')
save('H_a_GASS_griewank','H_GASS_a')
save('std_err_GASS_griewank','std_GASS')
save('S1_GASS_griewank','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_griewank, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_griewank','H_GASS_avg')
save('X_GASS_avg_griewank','X_GASS_avg')
save('H_a_GASS_avg_griewank','H_GASS_avg_a')
save('std_err_GASS_avg_griewank','std_GASS_avg')

figure
plot(S1,-zeros(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GASS_a)
hold on
plot(S1,H_GASS_avg_a,'--')
title('50-D Griewank function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -10 0.5])

%---------------levy function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
M=50;
Hl=-1e5;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_levy, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_levy','H_GASS')
save('X_GASS_levy','X_GASS')
save('H_a_GASS_levy','H_GASS_a')
save('std_err_GASS_levy','std_GASS')
save('S1_GASS_levy','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_levy, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_levy','H_GASS_avg')
save('X_GASS_avg_levy','X_GASS_avg')
save('H_a_GASS_avg_levy','H_GASS_avg_a')
save('std_err_GASS_avg_levy','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
legend('true optimum','GASS','GASS\_avg');
title('50-D Levy function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(4) -10^(-0.2)])


%----------------rastrigin function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
M=20;
Hl=-1e10;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_rastrigin, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_rastrigin','H_GASS')
save('X_GASS_rastrigin','X_GASS')
save('H_a_GASS_rastrigin','H_GASS_a')
save('std_err_GASS_rastrigin','std_GASS')
save('S1_GASS_rastrigin','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_rastrigin, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_rastrigin','H_GASS_avg')
save('X_GASS_avg_rastrigin','X_GASS_avg')
save('H_a_GASS_avg_rastrigin','H_GASS_avg_a')
save('std_err_GASS_avg_rastrigin','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
legend('true optimum','GASS','GASS\_avg');
title('20-D Rastrigin function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(4) -10^(-0.2)])

%----------------powel function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
M=50;
Hl=-1e10;
alpha=1;
rho=0.05;
c=0.002;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_powel, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_powel','H_GASS')
save('X_GASS_powel','X_GASS')
save('H_a_GASS_powel','H_GASS_a')
save('std_err_GASS_powel','std_GASS')
save('S1_GASS_powel','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_powel, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_powel','H_GASS_avg')
save('X_GASS_avg_powel','X_GASS_avg')
save('H_a_GASS_avg_powel','H_GASS_avg_a')
save('std_err_GASS_avg_powel','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
title('50-D Powel function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -10^(10) -10^(-0.2)])


%----------------pinter function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=1500; % number of maxmal iterations
M=50;
Hl=-5e6;
alpha=1;
rho=0.05;
c=0.002;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_pinter, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_pinter','H_GASS')
save('X_GASS_pinter','X_GASS')
save('H_a_GASS_pinter','H_GASS_a')
save('std_err_GASS_pinter','std_GASS')
save('S1_GASS_pinter','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_pinter, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_pinter','H_GASS_avg')
save('X_GASS_avg_pinter','X_GASS_avg')
save('H_a_GASS_avg_pinter','H_GASS_avg_a')
save('std_err_GASS_avg_pinter','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
title('50-D Pinter function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -10^(5) -10^(-0.2)])


%----------------rosenbrock function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=2500; % number of maxmal iterations
M=10;
Hl=-2e10;
alpha=0.3;
rho=0.02;
c=0.0005;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_rosenbrock, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_rosenbrock','H_GASS')
save('X_GASS_rosenbrock','X_GASS')
save('H_a_GASS_rosenbrock','H_GASS_a')
save('std_err_GASS_rosenbrock','std_GASS')
save('S1_GASS_rosenbrock','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_rosenbrock, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_rosenbrock','H_GASS_avg')
save('X_GASS_avg_rosenbrock','X_GASS_avg')
save('H_a_GASS_avg_rosenbrock','H_GASS_avg_a')
save('std_err_GASS_avg_rosenbrock','std_GASS_avg')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
title('10-D Rosenbrock function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -10^(4) -10^(-0.2)])

%----------------dejong5 function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=100; % number of maxmal iterations
M=2;
Hl=-1e4;
alpha=0.3;
rho=0.02;
c=0.1;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_dejong5, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_dejong5','H_GASS')
save('X_GASS_dejong5','X_GASS')
save('H_a_GASS_dejong5','H_GASS_a')
save('std_err_GASS_dejong5','std_GASS')
save('S1_GASS_dejong5','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_dejong5, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_dejong5','H_GASS_avg')
save('X_GASS_avg_dejong5','X_GASS_avg')
save('H_a_GASS_avg_dejong5','H_GASS_avg_a')
save('std_err_GASS_avg_dejong5','std_GASS_avg')

figure
plot(S1,-0.998*ones(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GASS_a)
hold on
plot(S1,H_GASS_avg_a,'--')
title('2-D Dejong5 function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) -4 -0.8])


%----------------shekel function----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=150; % number of maxmal iterations
M=4;
Hl=0;
alpha=0.3;
rho=0.02;
c=0.1;
for j=1:A
disp(j)
tic
[S1,H1,X1]=GASS(N, K, @flip_shekel, M, Hl, alpha, rho);
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_shekel','H_GASS')
save('X_GASS_shekel','X_GASS')
save('H_a_GASS_shekel','H_GASS_a')
save('std_err_GASS_shekel','std_GASS')
save('S1_GASS_shekel','S1')
for j=1:A
disp(j)
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_shekel, M, Hl, alpha, rho, c);
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_shekel','H_GASS_avg')
save('X_GASS_avg_shekel','X_GASS_avg')
save('H_a_GASS_avg_shekel','H_GASS_avg_a')
save('std_err_GASS_avg_shekel','std_GASS_avg')

figure
plot(S1,10.153*ones(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GASS_a)
hold on
plot(S1,H_GASS_avg_a,'--')
title('4-D Shekel function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg');
axis([0 S1(end) 0 10.5])