%---sphere-------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
choices=10;
M=50;
Hl=-2e6;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_sphere, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
std_GASS=std(H_GASS,0,1)/sqrt(A); % standard error
save('H_GASS_sphere','H_GASS')
save('X_GASS_sphere','X_GASS')
save('H_a_GASS_sphere','H_GASS_a')
save('std_err_GASS_sphere','std_GASS')
save('S1_GASS_sphere','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_sphere, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_sphere','H_GASS_avg')
save('X_GASS_avg_sphere','X_GASS_avg')
save('H_a_GASS_avg_sphere','H_GASS_avg_a')
save('std_err_GASS_avg_sphere','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_sphere, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_sphere','H_CEm')
save('X_CEm_sphere','X_CEm')
save('H_a_CEm_sphere','H_CEm_a')
save('std_err_CEm_sphere','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_sphere, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_sphere','H_MRAS')
save('X_MRAS_sphere','X_MRAS')
save('H_a_MRAS_sphere','H_MRAS_a')
save('std_err_MRAS_sphere','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
title('50-D Sphere function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
axis([0 S1(end) -10^(6) -10^(-0.2)])


%--------------------trigonometric----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=600; % number of maxmal iterations
choices=2;
M=50;
Hl=-1e5;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_tri, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_tri','H_GASS')
save('X_GASS_tri','X_GASS')
save('H_a_GASS_tri','H_GASS_a')
save('std_err_GASS_tri','std_GASS')
save('S1_GASS_tri','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_tri, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_tri','H_GASS_avg')
save('X_GASS_avg_tri','X_GASS_avg')
save('H_a_GASS_avg_tri','H_GASS_avg_a')
save('std_err_GASS_avg_tri','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_tri, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_tri','H_CEm')
save('X_CEm_tri','X_CEm')
save('H_a_CEm_tri','H_CEm_a')
save('std_err_CEm_tri','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_tri, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_tri','H_MRAS')
save('X_MRAS_tri','X_MRAS')
save('H_a_MRAS_tri','H_MRAS_a')
save('std_err_MRAS_tri','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
title('50-D Trigonometric function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
axis([0 S1(end) -10^(5) -10^(-0.2)])

%--------------------griewank----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
choices=3;
M=50;
Hl=-1e3;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_griewank, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_griewank','H_GASS')
save('X_GASS_griewank','X_GASS')
save('H_a_GASS_griewank','H_GASS_a')
save('std_err_GASS_griewank','std_GASS')
save('S1_GASS_griewank','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_griewank, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_griewank','H_GASS_avg')
save('X_GASS_avg_griewank','X_GASS_avg')
save('H_a_GASS_avg_griewank','H_GASS_avg_a')
save('std_err_GASS_avg_griewank','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_griewank, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_griewank','H_CEm')
save('X_CEm_griewank','X_CEm')
save('H_a_CEm_griewank','H_CEm_a')
save('std_err_CEm_griewank','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_griewank, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_griewank','H_MRAS')
save('X_MRAS_griewank','X_MRAS')
save('H_a_MRAS_griewank','H_MRAS_a')
save('std_err_MRAS_griewank','std_MRAS')

figure
plot(S1,-zeros(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GASS_a)
hold on
plot(S1,H_GASS_avg_a,'--')
hold on
plot(S1,H_CEm_a,'-.');
hold on
plot(S1,H_MRAS_a,':');
title('50-D Griewank function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
axis([0 S1(end) -10 0.5])

%--------------------levy----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
choices=7;
M=50;
Hl=-1e5;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_levy, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_levy','H_GASS')
save('X_GASS_levy','X_GASS')
save('H_a_GASS_levy','H_GASS_a')
save('std_err_GASS_levy','std_GASS')
save('S1_GASS_levy','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_levy, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_levy','H_GASS_avg')
save('X_GASS_avg_levy','X_GASS_avg')
save('H_a_GASS_avg_levy','H_GASS_avg_a')
save('std_err_GASS_avg_levy','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_levy, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_levy','H_CEm')
save('X_CEm_levy','X_CEm')
save('H_a_CEm_levy','H_CEm_a')
save('std_err_CEm_levy','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_levy, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_levy','H_MRAS')
save('X_MRAS_levy','X_MRAS')
save('H_a_MRAS_levy','H_MRAS_a')
save('std_err_MRAS_levy','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
title('50-D Levy function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(4) -10^(-0.2)])


%--------------------rastrigin----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
choices=8;
M=20;
Hl=-1e10;
alpha=1;
rho=0.05;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_rastrigin, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_rastrigin','H_GASS')
save('X_GASS_rastrigin','X_GASS')
save('H_a_GASS_rastrigin','H_GASS_a')
save('std_err_GASS_rastrigin','std_GASS')
save('S1_GASS_rastrigin','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_rastrigin, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_rastrigin','H_GASS_avg')
save('X_GASS_avg_rastrigin','X_GASS_avg')
save('H_a_GASS_avg_rastrigin','H_GASS_avg_a')
save('std_err_GASS_avg_rastrigin','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_rastrigin, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_rastrigin','H_CEm')
save('X_CEm_rastrigin','X_CEm')
save('H_a_CEm_rastrigin','H_CEm_a')
save('std_err_CEm_rastrigin','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_rastrigin, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_rastrigin','H_MRAS')
save('X_MRAS_rastrigin','X_MRAS')
save('H_a_MRAS_rastrigin','H_MRAS_a')
save('std_err_MRAS_rastrigin','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
title('20-D Rastrigin function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(4) -10^(-0.2)])

%--------------------powel----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=500; % number of maxmal iterations
choices=6;
M=50;
Hl=-1e10;
alpha=1;
rho=0.05;
c=0.002;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_powel, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_powel','H_GASS')
save('X_GASS_powel','X_GASS')
save('H_a_GASS_powel','H_GASS_a')
save('std_err_GASS_powel','std_GASS')
save('S1_GASS_powel','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_powel, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_powel','H_GASS_avg')
save('X_GASS_avg_powel','X_GASS_avg')
save('H_a_GASS_avg_powel','H_GASS_avg_a')
save('std_err_GASS_avg_powel','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_powel, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_powel','H_CEm')
save('X_CEm_powel','X_CEm')
save('H_a_CEm_powel','H_CEm_a')
save('std_err_CEm_powel','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_powel, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_powel','H_MRAS')
save('X_MRAS_powel','X_MRAS')
save('H_a_MRAS_powel','H_MRAS_a')
save('std_err_MRAS_powel','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
title('50-D Powel function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(10) -10^(-0.2)])


%--------------------pinter----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=1500; % number of maxmal iterations
choices=9;
M=50;
Hl=-5e6;
alpha=1;
rho=0.05;
c=0.002;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_pinter, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_pinter','H_GASS')
save('X_GASS_pinter','X_GASS')
save('H_a_GASS_pinter','H_GASS_a')
save('std_err_GASS_pinter','std_GASS')
save('S1_GASS_pinter','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_pinter, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_pinter','H_GASS_avg')
save('X_GASS_avg_pinter','X_GASS_avg')
save('H_a_GASS_avg_pinter','H_GASS_avg_a')
save('std_err_GASS_avg_pinter','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_pinter, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_pinter','H_CEm')
save('X_CEm_pinter','X_CEm')
save('H_a_CEm_pinter','H_CEm_a')
save('std_err_CEm_pinter','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_pinter, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_pinter','H_MRAS')
save('X_MRAS_pinter','X_MRAS')
save('H_a_MRAS_pinter','H_MRAS_a')
save('std_err_MRAS_pinter','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
title('50-D Pinter function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(5) -10^(-0.2)])


%--------------------rosenbrock----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=2500; % number of maxmal iterations
choices=1;
M=10;
Hl=-2e10;
alpha=0.3;
rho=0.02;
c=0.0005;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_rosenbrock, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_rosenbrock','H_GASS')
save('X_GASS_rosenbrock','X_GASS')
save('H_a_GASS_rosenbrock','H_GASS_a')
save('std_err_GASS_rosenbrock','std_GASS')
save('S1_GASS_rosenbrock','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_rosenbrock, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_rosenbrock','H_GASS_avg')
save('X_GASS_avg_rosenbrock','X_GASS_avg')
save('H_a_GASS_avg_rosenbrock','H_GASS_avg_a')
save('std_err_GASS_avg_rosenbrock','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_rosenbrock, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_rosenbrock','H_CEm')
save('X_CEm_rosenbrock','X_CEm')
save('H_a_CEm_rosenbrock','H_CEm_a')
save('std_err_CEm_rosenbrock','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_rosenbrock, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_rosenbrock','H_MRAS')
save('X_MRAS_rosenbrock','X_MRAS')
save('H_a_MRAS_rosenbrock','H_MRAS_a')
save('std_err_MRAS_rosenbrock','std_MRAS')

figure
semilogy(S1,-ones(1,length(S1)),'LineWidth',2)
hold on
semilogy(S1,H_GASS_a)
hold on
semilogy(S1,H_GASS_avg_a,'--')
hold on
semilogy(S1,H_CEm_a,'-.');
hold on
semilogy(S1,H_MRAS_a,':');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
title('10-D Rosenbrock function')
xlabel('Total sample size')
ylabel('Function value');
axis([0 S1(end) -10^(4) -10^(-0.2)])

%--------------------dejong5----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=100; % number of maxmal iterations
choices=5;
M=2;
Hl=-1e4;
alpha=0.3;
rho=0.02;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_dejong5, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_dejong5','H_GASS')
save('X_GASS_dejong5','X_GASS')
save('H_a_GASS_dejong5','H_GASS_a')
save('std_err_GASS_dejong5','std_GASS')
save('S1_GASS_dejong5','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_dejong5, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_dejong5','H_GASS_avg')
save('X_GASS_avg_dejong5','X_GASS_avg')
save('H_a_GASS_avg_dejong5','H_GASS_avg_a')
save('std_err_GASS_avg_dejong5','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_dejong5, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_dejong5','H_CEm')
save('X_CEm_dejong5','X_CEm')
save('H_a_CEm_dejong5','H_CEm_a')
save('std_err_CEm_dejong5','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_dejong5, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_dejong5','H_MRAS')
save('X_MRAS_dejong5','X_MRAS')
save('H_a_MRAS_dejong5','H_MRAS_a')
save('std_err_MRAS_dejong5','std_MRAS')


figure
plot(S1,-0.998*ones(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GASS_a)
hold on
plot(S1,H_GASS_avg_a,'--')
hold on
plot(S1,H_CEm_a,'-.');
hold on
plot(S1,H_MRAS_a,':');
title('2-D Dejong5 function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
axis([0 S1(end) -4 -0.8])


%--------------------shekel----------------
clear all;
warning off;
A=100;   %number of independent runs
N=1000;  % number of samples
K=150; % number of maxmal iterations
choices=4;
M=4;
Hl=0;
alpha=0.3;
rho=0.02;
c=0.1;
for j=1:A
tic
[S1,H1,X1]=GASS(N, K, @flip_shekel, M, Hl, alpha, rho);
disp(j)
H_GASS(j,:)=H1;
X_GASS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GASS_a=sum(H_GASS,1)/A;
std_GASS=std(H_GASS,0,1)/sqrt(A);
save('H_GASS_shekel','H_GASS')
save('X_GASS_shekel','X_GASS')
save('H_a_GASS_shekel','H_GASS_a')
save('std_err_GASS_shekel','std_GASS')
save('S1_GASS_shekel','S1')
for j=1:A
tic
[S1,H2,X2]=GASS_avg(N, K, @flip_shekel, M, Hl, alpha, rho, c);
disp(j)
H_GASS_avg(j,:)=H2;
X_GASS_avg(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_GASS_avg_a=sum(H_GASS_avg,1)/A;
std_GASS_avg=std(H_GASS_avg,0,1)/sqrt(A);
save('H_GASS_avg_shekel','H_GASS_avg')
save('X_GASS_avg_shekel','X_GASS_avg')
save('H_a_GASS_avg_shekel','H_GASS_avg_a')
save('std_err_GASS_avg_shekel','std_GASS_avg')
for j=1:A
tic
[S1,H3,X3]=CEm(N, K, @flip_shekel, M, rho);
disp(j)
H_CEm(j,:)=H3;
X_CEm(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_CEm_a=sum(H_CEm,1)/A;
std_CEm=std(H_CEm,0,1)/sqrt(A);
save('H_CEm_shekel','H_CEm')
save('X_CEm_shekel','X_CEm')
save('H_a_CEm_shekel','H_CEm_a')
save('std_err_CEm_shekel','std_CEm')
for j=1:A
tic
[S1,H4,X4]=MRAS(N, K, @flip_shekel, M, rho);
disp(j)
H_MRAS(j,:)=H4;
X_MRAS(j,:)=X4;
clear H4 X4;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_shekel','H_MRAS')
save('X_MRAS_shekel','X_MRAS')
save('H_a_MRAS_shekel','H_MRAS_a')
save('std_err_MRAS_shekel','std_MRAS')

figure
plot(S1,10.153*ones(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GASS_a)
hold on
plot(S1,H_GASS_avg_a,'--')
hold on
plot(S1,H_CEm_a,'-.');
hold on
plot(S1,H_MRAS_a,':');
title('4-D Shekel function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','GASS\_avg','modified CE','MRAS');
axis([0 S1(end) 0 10.5])


%----number of epsilon-optimal solutions
K1=length(S1);
opt=-1;   %10.15319585097904;
e=0.001;
M1=0;
A=100;
for k=1:A
if(H_GASS(k,K1)>=opt-e)
M1=M1+1;
end
end
M1
M2=0;
for k=1:A
if(H_GASS_avg(k,K1)>=opt-e)
M2=M2+1;
end
end
M2
M3=0;
for k=1:A
if(H_CEm(k,K1)>=opt-e)
M3=M3+1;
end
end
M3 
M4=0;
for k=1:A
if(H_MRAS(k,K1)>=opt-e)
M4=M4+1;
end
end
M4